﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;

namespace Sovest
{
    public partial class Form1 : Form
    {
        [DllImport("user32.dll")]
        private static extern IntPtr GetForegroundWindow();
        [DllImport("user32.dll")]
        private static extern int GetWindowText(IntPtr hWnd, StringBuilder text, int count);

        public int minutes = 0;
        public int last_minutes = 0;
        public int last_karma = -100;
        string today;
        RichTextBox good;
        RichTextBox bad;
        RichTextBox close;
        int goodc, badc, closec;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Form1.ActiveForm.Top = 0;
            Form1.ActiveForm.FormBorderStyle = FormBorderStyle.None;
            Timer t = new Timer();
            timer1.Enabled = true;
            Form1.ActiveForm.Height = 33;
            good = new RichTextBox();
            bad = new RichTextBox();
            close = new RichTextBox();
            try
            {
                good.LoadFile("good.txt", RichTextBoxStreamType.PlainText);
                bad.LoadFile("bad.txt", RichTextBoxStreamType.PlainText);
                close.LoadFile("close.txt", RichTextBoxStreamType.PlainText);
            }
            catch
            {
                good.SaveFile("good.txt", RichTextBoxStreamType.PlainText);
                bad.SaveFile("bad.txt", RichTextBoxStreamType.PlainText);
                close.SaveFile("close.txt", RichTextBoxStreamType.PlainText);
            }
            goodc=good.Lines.Length;
            badc=bad.Lines.Length;
            closec=close.Lines.Length;
            today = DateTime.Now.Day + "." + DateTime.Now.Month + "." + DateTime.Now.Year;
            try
            {
                richTextBox1.LoadFile("logs/log" + today + ".txt");
                richTextBox1.Text += "\n\n##################\n\n";

                richTextBox1.Select(richTextBox1.Text.Length, 1);
                richTextBox1.ScrollToCaret();
            }
            catch
            {
                richTextBox1.SaveFile("logs/log" + today + ".txt");
            }
            
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (textBox1.Text!= "!exit")
            e.Cancel = true;
    }

        private void label1_Click(object sender, EventArgs e)
        {
            
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int karma = 0;
            label1.Text = "";
            //Process p = new Process();
            //p=Process.GetProcesses()

            Process[] procList =  Process.GetProcesses(); 

            for ( int i=0; i<procList.Length; i++) 
            {
                for (int i2 = 0; i2 < goodc; i2++)
                {
                    if (procList[i].ProcessName == good.Lines[i2])
                    {
                        karma++;
                        label1.Text += " +" + procList[i].ProcessName;
                    }
                }
                for (int i2 = 0; i2 < badc; i2++)
                {
                    if (procList[i].ProcessName == bad.Lines[i2])
                    {
                        label1.Text += " -" + procList[i].ProcessName;
                        karma--;
                        karma--;
                    }
                }
                for (int i2 = 0; i2 < closec; i2++)
                {
                    if (procList[i].ProcessName == close.Lines[i2])
                    {
                        procList[i].CloseMainWindow();
                    }
                }

            }
            
            label1.Text = "Карма " + karma + " [" + label1.Text + "]";
            if (karma!=last_karma){
                richTextBox1.Text += "\t" + label1.Text + "\n";
            }
            last_karma=karma;
            
            int chars = 256;
            StringBuilder buff = new StringBuilder(chars);

            // Obtain the handle of the active window.
            IntPtr handle = GetForegroundWindow();

            // Update the controls.
            minutes++;
            last_minutes++;
            
            if (GetWindowText(handle, buff, chars) > 0)
            {
                richTextBox1.Text += "\t" + DateTime.Now + " - " + buff.ToString() + "\n";
                richTextBox1.Select(richTextBox1.Text.Length, 1);
                richTextBox1.ScrollToCaret();
                //treeView1.Nodes.Add(buff.ToString());
                    
                
                //lavel1.Text =buff.ToString();//заголовок окна
                //label1.Text =handle.ToString();//id процесса
            }
            richTextBox1.SaveFile("logs/log" + today + ".txt");
            if ((minutes % 20) == 0)//каждые 20 минут просим обновить задание
            {
                DialogResult result1 = MessageBox.Show("Обновить задание?", "Твоя Совесть", MessageBoxButtons.YesNo, MessageBoxIcon.Question,MessageBoxDefaultButton.Button2);
                if (result1 == DialogResult.Yes)
                {
                    label2.Visible = false;
                    textBox1.Visible = true;
                    textBox1.Focus();
                    textBox1.SelectAll();
                }
            }
            try
            {
                if (karma <= 0)
                {
                    Form1.ActiveForm.BackColor = Color.FromArgb(255, 0, 0);
                    Form1.ActiveForm.Opacity = 0.95;
                }
                else if (karma <= 2)
                {
                    Form1.ActiveForm.BackColor = Color.FromArgb(255, 255, 255);
                    Form1.ActiveForm.Opacity = 0.9;
                }
                else if (karma <= 4)
                {
                    Form1.ActiveForm.BackColor = Color.FromArgb(123, 255, 123);
                    Form1.ActiveForm.Opacity = 0.85;
                }
                else
                {
                    Form1.ActiveForm.BackColor = Color.FromArgb(90, 255, 90);
                    Form1.ActiveForm.Opacity = 0.8;
                }
            }
            catch
            {

            }
            label2.Text = textBox1.Text+" ["+last_minutes+" мин.]";
            if (textBox1.Visible == false)
            {
                if (richTextBox1.Visible == false)
                {
                    label2.Visible = true;
                }
            }
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        { 
            if (13 == e.KeyChar)
            {
                last_minutes = 0;
                textBox1.Visible = false;
                richTextBox1.Text+="Задача: "+textBox1.Text+"\n";
                last_minutes = 0;
                timer1_Tick(sender, e);
                label2.Visible = true;
                if (textBox1.Text == "!exit")
                {
                    Form1.ActiveForm.Close();
                }
            }
        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                if (richTextBox1.Visible)
                {
                    richTextBox1.Visible = false;
                    label2.Visible = false;
                    Form1.ActiveForm.Height = 33;
                }

                textBox1.Visible = !textBox1.Visible;
                if (textBox1.Visible == true)
                {
                    richTextBox1.Visible = false;
                    label2.Visible = false;
                    textBox1.Focus();
                    textBox1.SelectAll();
                }
                else
                {
                    richTextBox1.Visible = false;
                    label2.Visible = true;
                }
            }
            if (e.Button == MouseButtons.Right)
            {
                richTextBox1.Visible = !richTextBox1.Visible;
                if (richTextBox1.Visible)
                {
                    textBox1.Visible = false;
                    label2.Visible = false;
                    Form1.ActiveForm.Height = 500;
                    richTextBox1.Focus();
                }
                else
                {
                    richTextBox1.Select(richTextBox1.Text.Length, 1);
                    richTextBox1.ScrollToCaret();
                    textBox1.Visible = false;
                    label2.Visible = true;
                    Form1.ActiveForm.Height = 33;
                }
            }

        }

        private void richTextBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (27 == e.KeyChar)//esc
            {
                Form1.ActiveForm.Height = 33;
                richTextBox1.Visible = false;
                label2.Visible = true;
            }
        }

    }
}